'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CountMap = function () {
  function CountMap() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$array = _ref.array,
        array = _ref$array === undefined ? [] : _ref$array,
        _ref$hash = _ref.hash,
        hash = _ref$hash === undefined ? function (key) {
      return key.toString();
    } : _ref$hash,
        _ref$allowNegativeCou = _ref.allowNegativeCounts,
        allowNegativeCounts = _ref$allowNegativeCou === undefined ? false : _ref$allowNegativeCou;

    _classCallCheck(this, CountMap);

    this.counts = {};

    this.hash = hash;

    this.allowNegativeCounts = allowNegativeCounts;

    this.concat(array, true);
  }

  _createClass(CountMap, [{
    key: 'add',
    value: function add(key) {
      var amount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      if (amount < 0) {
        throw new RangeError('Amount should be positive. Try using subtract method.');
      }
      var hashed = this.hash(key);
      if (!this.counts[hashed]) {
        this.counts[hashed] = {
          hash: hashed,
          key: key,
          count: amount
        };
      } else {
        this.counts[hashed].count += amount;
      }
      return this.counts[hashed].count;
    }
  }, {
    key: 'subtract',
    value: function subtract(key) {
      var amount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      if (amount < 0) {
        throw new RangeError('Amount to subtract by should be positive.');
      }
      var hashed = this.hash(key);
      var entry = this.counts[hashed];
      if (entry) {
        entry.count = entry.count - amount;
        if (!this.allowNegativeCounts && entry.count < 0) {
          entry.count = 0;
        }
        return this.counts[hashed].count;
      }
      return 0;
    }
  }, {
    key: 'set',
    value: function set(key, amount) {
      if (!this.allowNegativeCounts && amount < 0) {
        throw new RangeError('Negative mode disabled. Amount should be positive.');
      }
      var hashed = this.hash(key);
      if (!this.counts[hashed]) {
        this.add(key, amount);
      } else {
        this.counts[hashed].count = amount;
      }
      return this.counts[hashed].count;
    }
  }, {
    key: 'concat',
    value: function concat(arr) {
      var inPlace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var map = inPlace ? this : this.clone();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = arr[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          map.add(key);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return map;
    }
  }, {
    key: 'delete',
    value: function _delete(key) {
      var hashed = this.hash(key);
      if (this.counts[hashed]) {
        delete this.counts[hashed];
        return true;
      }
      return false;
    }
  }, {
    key: 'get',
    value: function get(key) {
      var hashed = this.hash(key);
      return this.counts[hashed] ? this.counts[hashed].count : 0;
    }
  }, {
    key: 'has',
    value: function has(key) {
      var hashed = this.hash(key);
      return this.counts[hashed] !== undefined;
    }
  }, {
    key: 'clone',
    value: function clone() {
      var cloned = new CountMap({
        hash: this.hash,
        allowNegativeCounts: this.allowNegativeCounts
      });
      this.entries().forEach(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            key = _ref3[0],
            count = _ref3[1];

        cloned.set(key, count);
      });
      return cloned;
    }
  }, {
    key: 'rehash',
    value: function rehash() {
      var _this = this;

      var entries = this.entries();
      this.count = {};
      entries.forEach(function (_ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
            key = _ref5[0],
            count = _ref5[1];

        _this.add(key, count);
      });
      return this;
    }
  }, {
    key: 'keys',
    value: function keys() {
      return Object.values(this.counts).map(function (val) {
        return val.key;
      });
    }
  }, {
    key: 'entries',
    value: function entries() {
      return Object.values(this.counts).map(function (val) {
        return [val.key, val.count];
      });
    }
  }, {
    key: 'toArray',
    value: function toArray() {
      return this.entries().reduce(function (arr, _ref6) {
        var _ref7 = _slicedToArray(_ref6, 2),
            key = _ref7[0],
            count = _ref7[1];

        for (var i = 0; i < count; i++) {
          arr.push(key);
        }
        return arr;
      }, []);
    }
  }, {
    key: 'equals',
    value: function equals(other) {
      var _this2 = this;

      if (other.hash.toString() !== this.hash.toString() || other.allowNegativeCounts !== this.allowNegativeCounts) {
        return false;
      }
      var otherKeys = other.keys();
      var thisKeys = this.keys();
      var testKey = function testKey(key) {
        return _this2.get(key) === other.get(key);
      };
      var allKeysEqual = otherKeys.every(testKey) && thisKeys.every(testKey);
      return allKeysEqual;
    }
  }]);

  return CountMap;
}();

module.exports = CountMap;